package ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.plugin

import kotlin.contracts.InvocationKind
import kotlin.contracts.contract
import org.gradle.api.Project

@Suppress("unused")
fun Project.xomrk(config: XomrkDsl.() -> Unit) {
	contract {
		callsInPlace(config, InvocationKind.EXACTLY_ONCE)
	}

	if (null == this.plugins.findPlugin(SetupBuildScript::class.java)) {
		this.plugins.apply(SetupBuildScript::class.java)
	}

	val dsl = this.extensions.findByType(XomrkDsl::class.java) ?: throw RuntimeException("Can't install helper plugin")

	config(dsl)
}